#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include "util.h"
#include "kgb.h"
#include "admin.h"
#include "list.h"
#include "write.h"
#include "modify.h"
#include "delete.h"

char head_default[] =
"<html>
    <head>
        <title>Kiss CGI Guestbook</title>
    </head>
<body bgcolor='#ffffff'>
<center>
<p><a href='http://aeokiss.town.cc' target='top'><img src='icon/banner.gif' border='0' alt='Kiss CGI Development'></a></p>
</center>
";

char tail_default[] =
"
<center>
<p><font face='Arial' size='2'>Kiss CGI Development</font></p>
</center>
</body>
</html>";

void goList(KDB *kdb);

int main(void)
{
	FILE *fp;
	KDB kdb;
	CONFIG config;
	Entry *Econfig;
	char buff[0xff];
	int page;

	Content_Type("text/html");

	if((kdb.kdb = getValue("kdb")) == NULL)
		msg_error("Error!! Check request method with 'kdb=[dataname]'");

	sprintf(buff, "%s%s/%s", Save_Dir, kdb.kdb, kdb.kdb);
	if(FileCheck(buff) == 0)
		msg_error("Error!! Check request method with 'kdb=[dataname]'");

	/* get admin password */
	sprintf(buff, "%s%s/passwd", Save_Dir, kdb.kdb);
	Econfig = fileDecoder(buff);
	if(getFileValue(Econfig, "passwd") == NULL || getFileValue(Econfig, "passwd") == "")
		config.passwd = uReturnPasswd("kiss");
	else
		config.passwd = getFileValue(Econfig, "passwd");

	if((kdb.mode = getValue("mode")) == NULL)
		kdb.mode = "list";

	/* check new database */
	sprintf(buff, "%s%s.kdbm", Save_Dir, kdb.kdb);
	if(FileCheck(buff) == 0 && strcmp(kdb.mode, "adminform") && strcmp(kdb.mode, "adminsave"))
		kdb.mode = "admin";

	/* get data number */
	if(getValue("number") == NULL)
		kdb.number = 0;
	else
		kdb.number = atoi(getValue("number"));

	/* get information number */
	sprintf(buff, "%s%s/number.dat", Save_Dir, kdb.kdb);
	Econfig = fileDecoder(buff);

	if(getFileValue(Econfig, "volume") == NULL)
		config.volume = 0;
	else
		config.volume = atoi(getFileValue(Econfig, "volume"));

	if(getFileValue(Econfig, "lastnum") == NULL)
		config.lastnum = 0;
	else
		config.lastnum = atoi(getFileValue(Econfig, "lastnum"));

	if(config.volume > 0) {
		for(page = 1; page < (((config.volume - 1) / 10) + 2); page++) {
			sprintf(buff, "%dpage", page);
			kdb.pageact[page] = atoi(getFileValue(Econfig, buff));
		}
	}
	else
		kdb.pageact[1] = 0;

	if(getValue("page") == NULL)
		kdb.page = 1;
	else
		kdb.page = atoi(getValue("page"));

	sprintf(buff, "%s%s/head", Save_Dir, kdb.kdb);
	if(FileCheck(buff) == 0) {
		if((fp = fopen(buff, "wb")) == NULL)
			msg_error("Error!! (head html file save error");
		fprintf(fp, "%s", head_default);
		fclose(fp);
	}

	sprintf(buff, "%s%s/tail", Save_Dir, kdb.kdb);
	if(FileCheck(buff) == 0) {
		if((fp = fopen(buff, "wb")) == NULL)
			msg_error("Error!! (tail html file save error");
		fprintf(fp, "%s", tail_default);
		fclose(fp);
	}

	/* get configuration */
	sprintf(buff, "%s%s.kdbm", Save_Dir, kdb.kdb);
	Econfig = fileDecoder(buff);

	if((config.adsendmail = getFileValue(Econfig, "adsendmail")) == NULL)
		config.adsendmail = "OK";
	if((config.adminmail = getFileValue(Econfig, "adminmail")) == NULL)
		config.adminmail = "Your E-Mail Address";
	if((config.ahomeurl = getFileValue(Econfig, "ahomeurl")) == NULL)
		config.ahomeurl = "http://Your Homepage URL";
	if((config.atarget = getFileValue(Econfig, "atarget")) == NULL)
		config.atarget = "";
	if((config.backurl = getFileValue(Econfig, "backurl")) == NULL)
		config.backurl = "http://Back URL";
	if((config.btarget = getFileValue(Econfig, "btarget")) == NULL)
		config.btarget = "";
	if((config.helpurl = getFileValue(Econfig, "helpurl")) == NULL)
		config.helpurl = "log/help.html";
	if((config.htarget = getFileValue(Econfig, "htarget")) == NULL)
		config.htarget = "_blank";
	if((config.name = getFileValue(Econfig, "name")) == NULL)
		config.name = "OK";
	if((config.address = getFileValue(Econfig, "address")) == NULL)
		config.address = "NO";
	if((config.telephone = getFileValue(Econfig, "telephone")) == NULL)
		config.telephone = "NO";
	if((config.sex = getFileValue(Econfig, "sex")) == NULL)
		config.sex = "OPT";
	if((config.age = getFileValue(Econfig, "age")) == NULL)
		config.age = "NO";
	if((config.email = getFileValue(Econfig, "email")) == NULL)
		config.email = "OPT";
	if((config.homeurl = getFileValue(Econfig, "homeurl")) == NULL)
		config.homeurl = "OPT";
	if((config.hometitle = getFileValue(Econfig, "hometitle")) == NULL)
		config.hometitle = "OPT";
	if((config.body = getFileValue(Econfig, "body")) == NULL)
		config.body = "OK";
	if((config.language = getFileValue(Econfig, "language")) == NULL)
		config.language = "OK";
	if((config.accepthtml = getFileValue(Econfig, "accepthtml")) == NULL)
		config.accepthtml = "NO";
	if((config.underline = getFileValue(Econfig, "underline")) == NULL)
		config.underline = "NO";
	if((config.modifyarticle = getFileValue(Econfig, "modifyarticle")) == NULL)
		config.modifyarticle = "NO";
	if((config.topfcolor = getFileValue(Econfig, "topfcolor")) == NULL)
		config.topfcolor = "#000000";
	if((config.topbcolor = getFileValue(Econfig, "topbcolor")) == NULL)
		config.topbcolor = "#fff0f0";
	if((config.themefcolor = getFileValue(Econfig, "themefcolor")) == NULL)
		config.themefcolor = "#000000";
	if((config.themebcolor = getFileValue(Econfig, "themebcolor")) == NULL)
		config.themebcolor = "#f0f0f0";
	if((config.contentfcolor = getFileValue(Econfig, "contentfcolor")) == NULL)
		config.contentfcolor = "#000000";
	if((config.contentbcolor = getFileValue(Econfig, "contentbcolor")) == NULL)
		config.contentbcolor = "#ffffff";
	if((config.menuup = getFileValue(Econfig, "menuup")) == NULL)
		config.menuup = "NO";

	if(!strcmp(kdb.mode, "list"))
		list(&kdb, &config);
	else if(!strcmp(kdb.mode, "admin"))
		admin(&kdb);
	else if(!strcmp(kdb.mode, "adminform"))
		adminform(&kdb, &config);
	else if(!strcmp(kdb.mode, "adminsave")) {
		adminsave(&kdb, &config);
		goList(&kdb);
	}
	else if(!strcmp(kdb.mode, "write"))
		write(&kdb, &config);
	else if(!strcmp(kdb.mode, "writesave")) {
		writesave(&kdb, &config);
		goList(&kdb);
	}
	else if(!strcmp(kdb.mode, "modify"))
		modify(&kdb);
	else if(!strcmp(kdb.mode, "modifyform"))
		modifyform(&kdb, &config);
	else if(!strcmp(kdb.mode, "modifysave")) {
		modifysave(&kdb, &config);
		goList(&kdb);
	}
	else if(!strcmp(kdb.mode, "del"))
		del(&kdb);
	else if(!strcmp(kdb.mode, "delfrom")) {
		delfrom(&kdb, &config);
		goList(&kdb);
	}
	else msg_error("Error!! Unknow mode. Check Mode");

	entryFree();
	entryFileFree(Econfig);

	return 0;
}

void PrintHeadHtml(char *kdb)
{
	char buff[0xff];

	sprintf(buff, "%s%s/head", Save_Dir, kdb);
	uReadFile(buff);
}

void PrintTailHtml(char *kdb)
{
	char buff[0xff];

	sprintf(buff, "%s%s/tail", Save_Dir, kdb);
	uReadFile(buff);
}

/* ----------------------------------------------------------
   [  α׷  ]
    κ   ϴ.
    Ʒκ Ͽ   ڴ  α׷
    㰡  ϴ.
   ---------------------------------------------------------- */
void Developer_Message(void)
{
	printf("<!--   Program Information  -->\n");
	printf("<!--  Title        : %-44s -->\n", Title_Name);
	printf("<!--  Program Name : %-44s -->\n", Program_Name);
	printf("<!--  Version      : %-44s -->\n", Program_Version);
	printf("<!--  Last Update  : %-44s -->\n", Last_Updated);
	printf("<!--                                     KISS CGI Development     -->\n");
	printf("<!--  Developed by 'Kang, Hoon joo'                               -->\n");
	printf("<!--  E-mail       : aeokiss@shinbiro.com                         -->\n");
	printf("<!--  Homepage URL : http://aeokiss.town.cc                       -->\n");
	printf("<!--  -->\n\n\n");
	return;
/* ----------------------------------------------------------
     α׷ Ͽ     ϰ
         Ʒ  
   ֽñ⸦ Ź帳ϴ.
   ---------------------------------------------------------- */
	printf("<!--  Modify Information  -->\n");
	printf("<!--                                                              -->\n");
	printf("<!--                                                              -->\n");
	printf("<!--                                                              -->\n");
	printf("<!--                                                              -->\n");
	printf("<!--  -->\n\n\n");
	return;
}

void linescan(KDB *kdb, CONFIG *config)
{
	FILE *fp;
	char file1[0xff], file2[0xff];
	int visual, page, temp, volume, pageact[Max_Page];

	pageact[1] = visual = config->lastnum;
	temp = 0;
	page = 2;
	volume = 0;

	while(1) {
		if(visual < 1) {
			pageact[page] = -1;
			break;
		}

		sprintf(file1, "%s%s/%d.bone", Save_Dir, kdb->kdb, visual);
		sprintf(file2, "%s%s/%d.body", Save_Dir, kdb->kdb, visual);

		if(FileCheck(file1) == 1 || FileCheck(file2) == 1) {
			temp++;
			volume++;
			if(temp == 10) {
				pageact[page] = visual - 1;
				page++;
				temp = 0;
			}
		}

		visual--;
	}

	sprintf(file1, "%s%s/number.dat", Save_Dir, kdb->kdb);

	if((fp = fopen(file1, "wt")) == NULL)
		msg_error("Error!! Please, You should better call the administror 'write mode number'");

	fprintf(fp, "lastnum=%d\n", config->lastnum);
	fprintf(fp, "volume=%d\n", volume);

	page = 1;
	while(pageact[page] != -1) {
		fprintf(fp, "%dpage=%d\n", page, pageact[page]);
		page++;
	}

	fclose(fp);
}


void goList(KDB *kdb)
{
	printf("<html>\n");
	printf("<head>\n");

	printf("  <title>Please, wait a second while refreshing page</title>\n");

	printf("  <meta http-equiv=\"refresh\" content=\"0; url=%s?kdb=%s\">\n", Program_Name, kdb->kdb);

	printf("</head>\n");
	printf("</html>\n");
	exit(0);
}
