#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include "util.h"

char *getQuery(char *method);
void decodeQuery(char *str);
char x2c(char hex_up, char hex_low);
char *makeword(char *str, char stop);
char *deleteSpace(char *str);

static Entry *fentry = NULL;
static int _space;

char *getValue(char *name)
{
	Entry *entries;

	if(fentry == NULL)
		Decoder();

	entries = fentry;

	while(entries) {
		if(!strcmp(name, entries->name))
			return (entries->value);
		entries = entries->next;
	}

	return NULL;
}


int Decoder(void)
{
	Entry *entries, *back;
	char *query;
	int  amount;

	if(fentry != NULL)
		return -1;

	entries = back = NULL;

	query = getQuery("GET");
	for(amount = 0; query && *query; amount++) {
		back = entries;
		entries = (Entry *)malloc(sizeof(Entry));
		if(back != NULL)
			back->next = entries;
		if(fentry == NULL)
			fentry = entries;
		entries->value = makeword(query, '&');
		entries->name  = makeword(entries->value, '=');
		entries->next = NULL;
		decodeQuery(entries->name);
		decodeQuery(entries->value);
	}
	if(query)
		free(query);

	query = getQuery("POST");
	for( ; query && *query; amount++) {
		back = entries;
		entries = (Entry *)malloc(sizeof(Entry));
		if(back != NULL)
			back->next = entries;
		if(fentry == NULL)
			fentry=entries;

		entries->value = makeword(query, '&');
		entries->name  = makeword(entries->value, '=');
		entries->next = NULL;

		decodeQuery(entries->name);
		decodeQuery(entries->value);
	}
	if(query)
		free(query);

	return amount;
}


void entryFree(void)
{
	Entry *next;

	for( ; fentry; fentry = next) {
		next = fentry->next;
		free(fentry->name);
		free(fentry->value);
		free(fentry);
	}
	fentry = NULL;
}


Entry *fileDecoder(char *filename)
{
	FILE *fp;
	Entry *first, *entries, *back;
	char buff[1000 + 1];

	if((fp = fopen(filename, "rt")) == NULL)
		return NULL;

	first = entries = back = NULL;

	while(fgets(buff, sizeof(buff), fp)) {
		back = entries;
		entries = (Entry *)malloc(sizeof(Entry));
		if(back != NULL)
			back->next = entries;
		if(first == NULL)
			first = entries;

		entries->value = (char *)malloc(sizeof(char) * (strlen(buff) + 1));
		strcpy(entries->value, buff);
		entries->name = makeword(entries->value, '=');
		entries->next = NULL;

		deleteSpace(entries->name);
		deleteSpace(entries->value);
	}

	fclose(fp);
	return first;
}


char *getFileValue(Entry *first, char *name)
{
	Entry *entries;

	entries = first;

	while(entries) {
		if(!strcmp(name, entries->name))
			return (entries->value);
		entries = entries->next;
	}

	return NULL;
}


void entryFileFree(Entry *first)
{
	Entry *next;

	for( ; first; first = next) {
		next = first->next;
		free(first->name);
		free(first->value);
		free(first);
	}

	first = NULL;
}


void uReadFile(char *filename)
{
	FILE *fp;
	char ch;

	if((fp = fopen(filename, "rt")) == NULL) {
		msg_error("file Open ERROR !! Check save directory");
	}

	while((ch = fgetc(fp)) != EOF)
		printf("%c", ch);

	fclose(fp);
}


void uBodyReadFile(char *filename, int flag)
{
	FILE *fp;
	char ch;

	if((fp = fopen(filename, "rt")) == NULL) {
		msg_error("file Open ERROR !! Check save directory");
	}

	if(flag) {
		while((ch = fgetc(fp)) != EOF) {
			switch(ch) {
				case '\n' :
					printf("<br>");
					_space = 0;
					break;
				case ' ' :
					if(_space == 1) {
						printf("&nbsp;");
					}
					else {
						printf(" ");
						_space = 1;
					}
					break;
				case '<' :
					printf("&lt;");
					_space = 0;
					break;
				case '>' :
					printf("&gt;");
					_space = 0;
					break;
				case '"' :
					printf("&quot;");
					_space = 0;
					break;
				case '&' :
					printf("&amp;");
					_space = 0;
					break;
				default :
					printf("%c", ch);
					_space = 0;
					break;
			}
		}
	}

	else {
		while((ch = fgetc(fp)) != EOF) {
			switch(ch) {
				case '\n' :
					printf("<br>");
					break;
				default :
					printf("%c", ch);
					break;
			}
		}
	}

	fclose(fp);
}


void print_html_code(char *filename)
{
	FILE *fp;
	char ch;

	if((fp = fopen(filename, "rt")) == NULL) {
		msg_error("file Open ERROR !! Check save directory");
	}

	while((ch = fgetc(fp)) != EOF) {
		switch(ch) {
			case '<' :
				printf("&lt;");
				break;
			case '>' :
				printf("&gt;");
				break;
			case '"' :
				printf("&quot;");
				break;
			case '&' :
				printf("&amp;");
				break;
			default :
				printf("%c", ch);
				break;
		}
	}
	fclose(fp);
}


char *ucReadFile(char *filename)
{
	FILE *fp;
	char *temp = NULL;

	if((fp = fopen(filename, "rb")) == NULL)
		return NULL;

	fscanf(fp, "%s", temp);

	fclose(fp);
	return temp;
}


void uWriteFile(char *filename, char *body)
{
    FILE *fp;

    if((fp = fopen(filename, "wb")) == NULL) {
        msg_error("File Write Error!! (Check Permission)");
    }

    fprintf(fp, "%s", body);
    fclose(fp);
}


char *uReturnPasswd(char *passwd)
{
	return crypt(passwd, "Kiss");
}


int uReadNum(char *filename)
{
	FILE *fp;
	unsigned long i;

	if((fp = fopen(filename, "rb")) == NULL) {
		return 0;
	}
	fscanf(fp, "%ld", &i);
	return i;
}


int uWriteNum(char *filename, unsigned long num)
{
	FILE *fp;

	if((fp = fopen(filename, "wb")) == NULL) {
		return 0;
	}

	fprintf(fp, "%ld", num);
	fclose(fp);

	return 1;
}


int FileCheck(char *filename)
{
	FILE *fp;

	if((fp = fopen(filename, "rb")) == NULL)
		return 0;

	fclose(fp);

	return 1;
}


void msg_error(char *eMsg)
{
	printf("<html>\n");
	printf("<head>\n");
	printf("    <title>Error!!</title>\n");
	printf("</head>\n");
	printf("<body bgcolor='white'>\n<br><br>\n<center>\n");
	printf("    <p><font face='Arial' size='5' color='red'><b>%s<b></font></p>\n", eMsg);
	printf("    <p><font face='Arial' size='2' color='black'>Developed by 'Hoon-joo, Kang' <a href='mailto:aeokiss@shinbiro.com'><br><i>aeokiss@shinbiro.com</i></a></font>\n");
	printf("    <p><font face='Arial' size='4'><a href='javascript:history.go(-1)' onMouseOver=\"window.status=('Go back'); return true;\">Back</a></font>\n");
	printf("</body>\n</html>\n");

	exit(1);
}


void Content_Type(char *Type)
{
	printf("Content-type: %s%c%c", Type, 10, 10);
}


void Disable_Underlined(void)
{
	printf("\n");
	printf("<style type='text/css'>\n");
	printf("<!--\n");
	printf("    a:link    {text-decoration:none}\n");
	printf("    a:active  {text-decoration:none}\n");
	printf("    a:visited {text-decoration:none}\n");
	printf("    a:hover   {text-decoration:underline}\n");
	printf("-->\n");
	printf("</style>\n");
	printf("\n");
}


char *getQuery(char *method)
{
	char *query;
	int cl, i;

	if(!strcmp(method, "GET")) {
		if(getenv("QUERY_STRING") == NULL)
			return NULL;
		query = (char *)malloc(sizeof(char) * (strlen(getenv("QUERY_STRING")) + 1));
		strcpy(query, getenv("QUERY_STRING"));
		return query;
	}
	if(!strcmp(method, "POST")) {
		if(getenv("REQUEST_METHOD") == NULL)
			return NULL;
		if(strcmp("POST", getenv("REQUEST_METHOD")))
			return NULL;
		cl = atoi(getenv("CONTENT_LENGTH"));
		query = (char *)malloc(sizeof(char) * (cl + 1));
		for(i = 0; i < cl; i++)
			query[i] = fgetc(stdin);
		query[i] = '\0';
		return query;
	}
	return NULL;
}


void decodeQuery(char *str)
{
	int i, j;

	if(!str)
		return;
    for(i = j = 0; str[j]; i++, j++) {
		switch(str[j]) {
			case '+' :
				str[i] = ' ';
				break;
			case '%' :
				str[i] = x2c(str[j + 1], str[j + 2]);
				j += 2;
				break;
			default :
				str[i] = str[j];
				break;
		}
	}
	str[i]='\0';
}


char x2c(char hex_up, char hex_low)
{
	char digit;

	digit = 16 * (hex_up >= 'A' ? ((hex_up & 0xdf) - 'A') + 10 : (hex_up - '0'));
	digit += (hex_low >= 'A' ? ((hex_low & 0xdf) - 'A') + 10 : (hex_low - '0'));

	return (digit);
}


char *makeword(char *str, char stop)
{
	char *word;
	int  len, i;

	for(len = 0; ((str[len] != stop) && (str[len])); len++);
	word = (char *)malloc(sizeof(char) * (len + 1));

	for(i = 0; i < len; i++)
		word[i] = str[i];
	word[i] = '\0';

	if(str[len])len++;
	for(i = len; str[i]; i++)
		str[i - len] = str[i];
	str[i - len] = '\0';

	return (word);
}


char *deleteSpace(char *str)
{
	int i, j;

	if(!str)
		return NULL;

	for(j = 0; str[j] == ' ' || str[j] == 9; j++);
	for(i = 0; str[j] != '\0'; i++, j++)
		str[i] = str[j];
	for(i--; (i >= 0) && (str[i] == ' ' || str[i] == 9 || str[i] == '\r' || str[i] == '\n'); i--);
	str[i+1] = '\0';

	return str;
}
